/*
 * $Id: auto.c.in,v 1.3 2000/12/01 08:10:40 hubbe Exp $
 *
 */

#include "global.h"

#include "config.h"

RCSID("$Id: auto.c.in,v 1.3 2000/12/01 08:10:40 hubbe Exp $");
#include "stralloc.h"
#include "pike_macros.h"
#include "object.h"
#include "program.h"
#include "interpret.h"
#include "builtin_functions.h"
#include "pike_error.h"
#include "module_support.h"
#include "operators.h"

#define GLUT_API_VERSION 4

#ifdef HAVE_GL_GLUT_H
#include <GL/glut.h>
#endif

#include "module_magic.h"

static void pre_init()
{
}

static void f_glutInit(INT32 args)
{
  int argc = 1;
  extern char ** ARGV;
  glutInit(&argc,ARGV);
  pop_n_elems(args);
}

static void post_init()
{
  add_function_constant("glutInit", f_glutInit,
			"function(void:void)", OPT_SIDE_EFFECT);
}




static void f_glutAddMenuEntry(INT32 args)
{
  char *arg1;
  INT32 arg2;

  check_all_args("glutAddMenuEntry", args, BIT_STRING, BIT_INT, 0);

  arg1=sp[0-args].u.string->str;
  arg2=sp[1-args].u.integer;

  glutAddMenuEntry(arg1,arg2);
  pop_n_elems(args);
}

static void f_glutAddSubMenu(INT32 args)
{
  char *arg1;
  INT32 arg2;

  check_all_args("glutAddSubMenu", args, BIT_STRING, BIT_INT, 0);

  arg1=sp[0-args].u.string->str;
  arg2=sp[1-args].u.integer;

  glutAddSubMenu(arg1,arg2);
  pop_n_elems(args);
}

static void f_glutAttachMenu(INT32 args)
{
  INT32 arg1;

  check_all_args("glutAttachMenu", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutAttachMenu(arg1);
  pop_n_elems(args);
}

struct svalue glutButtonBoxFunc_fun;

void glutButtonBoxFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutButtonBoxFunc_fun, 2);
  pop_stack();
}

static void f_glutButtonBoxFunc(INT32 args)
{
  if(glutButtonBoxFunc_fun.type)
    free_svalue(&glutButtonBoxFunc_fun);
  assign_svalue_no_free(&glutButtonBoxFunc_fun, &sp[-args+0]);

  check_all_args("glutButtonBoxFunc", args, BIT_FUNCTION, 0);
  glutButtonBoxFunc((void *)&glutButtonBoxFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutChangeToMenuEntry(INT32 args)
{
  INT32 arg1;
  char *arg2;
  INT32 arg3;

  check_all_args("glutChangeToMenuEntry", args, BIT_INT, BIT_STRING, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.string->str;
  arg3=sp[2-args].u.integer;

  glutChangeToMenuEntry(arg1,arg2,arg3);
  pop_n_elems(args);
}

static void f_glutChangeToSubMenu(INT32 args)
{
  INT32 arg1;
  char *arg2;
  INT32 arg3;

  check_all_args("glutChangeToSubMenu", args, BIT_INT, BIT_STRING, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.string->str;
  arg3=sp[2-args].u.integer;

  glutChangeToSubMenu(arg1,arg2,arg3);
  pop_n_elems(args);
}

static void f_glutCopyColormap(INT32 args)
{
  INT32 arg1;

  check_all_args("glutCopyColormap", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutCopyColormap(arg1);
  pop_n_elems(args);
}

struct svalue glutCreateMenu_fun;

void glutCreateMenu_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutCreateMenu_fun, 1);
  pop_stack();
}

static void f_glutCreateMenu(INT32 args)
{
  INT32 res;
  if(glutCreateMenu_fun.type)
    free_svalue(&glutCreateMenu_fun);
  assign_svalue_no_free(&glutCreateMenu_fun, &sp[-args+0]);

  check_all_args("glutCreateMenu", args, BIT_FUNCTION, 0);
  res=glutCreateMenu((void *)&glutCreateMenu_cb_wrapper);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutCreateSubWindow(INT32 args)
{
  INT32 res;
  INT32 arg1;
  INT32 arg2;
  INT32 arg3;
  INT32 arg4;
  INT32 arg5;

  check_all_args("glutCreateSubWindow", args, BIT_INT, BIT_INT, BIT_INT, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;
  arg5=sp[4-args].u.integer;

  res=glutCreateSubWindow(arg1,arg2,arg3,arg4,arg5);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutCreateWindow(INT32 args)
{
  INT32 res;
  char *arg1;

  check_all_args("glutCreateWindow", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  res=glutCreateWindow(arg1);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutDestroyMenu(INT32 args)
{
  INT32 arg1;

  check_all_args("glutDestroyMenu", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutDestroyMenu(arg1);
  pop_n_elems(args);
}

static void f_glutDestroyWindow(INT32 args)
{
  INT32 arg1;

  check_all_args("glutDestroyWindow", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutDestroyWindow(arg1);
  pop_n_elems(args);
}

static void f_glutDetachMenu(INT32 args)
{
  INT32 arg1;

  check_all_args("glutDetachMenu", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutDetachMenu(arg1);
  pop_n_elems(args);
}

static void f_glutDeviceGet(INT32 args)
{
  INT32 res;
  INT32 arg1;

  check_all_args("glutDeviceGet", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  res=glutDeviceGet(arg1);
  pop_n_elems(args);
  push_int(res);
}

struct svalue glutDialsFunc_fun;

void glutDialsFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutDialsFunc_fun, 2);
  pop_stack();
}

static void f_glutDialsFunc(INT32 args)
{
  if(glutDialsFunc_fun.type)
    free_svalue(&glutDialsFunc_fun);
  assign_svalue_no_free(&glutDialsFunc_fun, &sp[-args+0]);

  check_all_args("glutDialsFunc", args, BIT_FUNCTION, 0);
  glutDialsFunc((void *)&glutDialsFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutDisplayFunc_fun;

void glutDisplayFunc_cb_wrapper(void)
{

  apply_svalue(&glutDisplayFunc_fun, 0);
  pop_stack();
}

static void f_glutDisplayFunc(INT32 args)
{
  if(glutDisplayFunc_fun.type)
    free_svalue(&glutDisplayFunc_fun);
  assign_svalue_no_free(&glutDisplayFunc_fun, &sp[-args+0]);

  check_all_args("glutDisplayFunc", args, BIT_FUNCTION, 0);
  glutDisplayFunc((void *)&glutDisplayFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutEnterGameMode(INT32 args)
{
  INT32 res;
  res=glutEnterGameMode();
  pop_n_elems(args);
  push_int(res);
}

struct svalue glutEntryFunc_fun;

void glutEntryFunc_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutEntryFunc_fun, 1);
  pop_stack();
}

static void f_glutEntryFunc(INT32 args)
{
  if(glutEntryFunc_fun.type)
    free_svalue(&glutEntryFunc_fun);
  assign_svalue_no_free(&glutEntryFunc_fun, &sp[-args+0]);

  check_all_args("glutEntryFunc", args, BIT_FUNCTION, 0);
  glutEntryFunc((void *)&glutEntryFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutEstablishOverlay(INT32 args)
{
  glutEstablishOverlay();
  pop_n_elems(args);
}

static void f_glutExtensionSupported(INT32 args)
{
  INT32 res;
  char *arg1;

  check_all_args("glutExtensionSupported", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  res=glutExtensionSupported(arg1);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutForceJoystickFunc(INT32 args)
{
  glutForceJoystickFunc();
  pop_n_elems(args);
}

static void f_glutFullScreen(INT32 args)
{
  glutFullScreen();
  pop_n_elems(args);
}

static void f_glutGameModeGet(INT32 args)
{
  INT32 res;
  INT32 arg1;

  check_all_args("glutGameModeGet", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  res=glutGameModeGet(arg1);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutGameModeString(INT32 args)
{
  char *arg1;

  check_all_args("glutGameModeString", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  glutGameModeString(arg1);
  pop_n_elems(args);
}

static void f_glutGet(INT32 args)
{
  INT32 res;
  INT32 arg1;

  check_all_args("glutGet", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  res=glutGet(arg1);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutGetColor(INT32 args)
{
  float res;
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutGetColor", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  res=glutGetColor(arg1,arg2);
  pop_n_elems(args);
  push_float(res);
}

static void f_glutGetMenu(INT32 args)
{
  INT32 res;
  res=glutGetMenu();
  pop_n_elems(args);
  push_int(res);
}

static void f_glutGetModifiers(INT32 args)
{
  INT32 res;
  res=glutGetModifiers();
  pop_n_elems(args);
  push_int(res);
}

static void f_glutGetWindow(INT32 args)
{
  INT32 res;
  res=glutGetWindow();
  pop_n_elems(args);
  push_int(res);
}

static void f_glutHideOverlay(INT32 args)
{
  glutHideOverlay();
  pop_n_elems(args);
}

static void f_glutHideWindow(INT32 args)
{
  glutHideWindow();
  pop_n_elems(args);
}

static void f_glutIconifyWindow(INT32 args)
{
  glutIconifyWindow();
  pop_n_elems(args);
}

struct svalue glutIdleFunc_fun;

void glutIdleFunc_cb_wrapper(void)
{

  apply_svalue(&glutIdleFunc_fun, 0);
  pop_stack();
}

static void f_glutIdleFunc(INT32 args)
{
  if(glutIdleFunc_fun.type)
    free_svalue(&glutIdleFunc_fun);
  assign_svalue_no_free(&glutIdleFunc_fun, &sp[-args+0]);

  check_all_args("glutIdleFunc", args, BIT_FUNCTION, 0);
  glutIdleFunc((void *)&glutIdleFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutIgnoreKeyRepeat(INT32 args)
{
  INT32 arg1;

  check_all_args("glutIgnoreKeyRepeat", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutIgnoreKeyRepeat(arg1);
  pop_n_elems(args);
}

static void f_glutInitDisplayMode(INT32 args)
{
  INT32 arg1;

  check_all_args("glutInitDisplayMode", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutInitDisplayMode(arg1);
  pop_n_elems(args);
}

static void f_glutInitDisplayString(INT32 args)
{
  char *arg1;

  check_all_args("glutInitDisplayString", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  glutInitDisplayString(arg1);
  pop_n_elems(args);
}

static void f_glutInitWindowPosition(INT32 args)
{
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutInitWindowPosition", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutInitWindowPosition(arg1,arg2);
  pop_n_elems(args);
}

static void f_glutInitWindowSize(INT32 args)
{
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutInitWindowSize", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutInitWindowSize(arg1,arg2);
  pop_n_elems(args);
}

struct svalue glutJoystickFunc_fun;

void glutJoystickFunc_cb_wrapper(unsigned int arg1, int arg2, int arg3, int arg4)
{
  push_int((int)arg1);
  push_int(arg2);
  push_int(arg3);
  push_int(arg4);
  apply_svalue(&glutJoystickFunc_fun, 4);
  pop_stack();
}

static void f_glutJoystickFunc(INT32 args)
{
  INT32 arg1;
  if(glutJoystickFunc_fun.type)
    free_svalue(&glutJoystickFunc_fun);
  assign_svalue_no_free(&glutJoystickFunc_fun, &sp[-args+0]);

  check_all_args("glutJoystickFunc", args, BIT_FUNCTION, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutJoystickFunc((void *)&glutJoystickFunc_cb_wrapper,arg1);
  pop_n_elems(args);
}

struct svalue glutKeyboardFunc_fun;

void glutKeyboardFunc_cb_wrapper(unsigned int arg1, int arg2, int arg3)
{
  push_int((int)arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutKeyboardFunc_fun, 3);
  pop_stack();
}

static void f_glutKeyboardFunc(INT32 args)
{
  if(glutKeyboardFunc_fun.type)
    free_svalue(&glutKeyboardFunc_fun);
  assign_svalue_no_free(&glutKeyboardFunc_fun, &sp[-args+0]);

  check_all_args("glutKeyboardFunc", args, BIT_FUNCTION, 0);
  glutKeyboardFunc((void *)&glutKeyboardFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutKeyboardUpFunc_fun;

void glutKeyboardUpFunc_cb_wrapper(unsigned int arg1, int arg2, int arg3)
{
  push_int((int)arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutKeyboardUpFunc_fun, 3);
  pop_stack();
}

static void f_glutKeyboardUpFunc(INT32 args)
{
  if(glutKeyboardUpFunc_fun.type)
    free_svalue(&glutKeyboardUpFunc_fun);
  assign_svalue_no_free(&glutKeyboardUpFunc_fun, &sp[-args+0]);

  check_all_args("glutKeyboardUpFunc", args, BIT_FUNCTION, 0);
  glutKeyboardUpFunc((void *)&glutKeyboardUpFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutLayerGet(INT32 args)
{
  INT32 res;
  INT32 arg1;

  check_all_args("glutLayerGet", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  res=glutLayerGet(arg1);
  pop_n_elems(args);
  push_int(res);
}

static void f_glutLeaveGameMode(INT32 args)
{
  glutLeaveGameMode();
  pop_n_elems(args);
}

static void f_glutMainLoop(INT32 args)
{
  glutMainLoop();
  pop_n_elems(args);
}

struct svalue glutMenuStateFunc_fun;

void glutMenuStateFunc_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutMenuStateFunc_fun, 1);
  pop_stack();
}

static void f_glutMenuStateFunc(INT32 args)
{
  if(glutMenuStateFunc_fun.type)
    free_svalue(&glutMenuStateFunc_fun);
  assign_svalue_no_free(&glutMenuStateFunc_fun, &sp[-args+0]);

  check_all_args("glutMenuStateFunc", args, BIT_FUNCTION, 0);
  glutMenuStateFunc((void *)&glutMenuStateFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutMenuStatusFunc_fun;

void glutMenuStatusFunc_cb_wrapper(int arg1, int arg2, int arg3)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutMenuStatusFunc_fun, 3);
  pop_stack();
}

static void f_glutMenuStatusFunc(INT32 args)
{
  if(glutMenuStatusFunc_fun.type)
    free_svalue(&glutMenuStatusFunc_fun);
  assign_svalue_no_free(&glutMenuStatusFunc_fun, &sp[-args+0]);

  check_all_args("glutMenuStatusFunc", args, BIT_FUNCTION, 0);
  glutMenuStatusFunc((void *)&glutMenuStatusFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutMotionFunc_fun;

void glutMotionFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutMotionFunc_fun, 2);
  pop_stack();
}

static void f_glutMotionFunc(INT32 args)
{
  if(glutMotionFunc_fun.type)
    free_svalue(&glutMotionFunc_fun);
  assign_svalue_no_free(&glutMotionFunc_fun, &sp[-args+0]);

  check_all_args("glutMotionFunc", args, BIT_FUNCTION, 0);
  glutMotionFunc((void *)&glutMotionFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutMouseFunc_fun;

void glutMouseFunc_cb_wrapper(int arg1, int arg2, int arg3, int arg4)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  push_int(arg4);
  apply_svalue(&glutMouseFunc_fun, 4);
  pop_stack();
}

static void f_glutMouseFunc(INT32 args)
{
  if(glutMouseFunc_fun.type)
    free_svalue(&glutMouseFunc_fun);
  assign_svalue_no_free(&glutMouseFunc_fun, &sp[-args+0]);

  check_all_args("glutMouseFunc", args, BIT_FUNCTION, 0);
  glutMouseFunc((void *)&glutMouseFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutOverlayDisplayFunc_fun;

void glutOverlayDisplayFunc_cb_wrapper(void)
{

  apply_svalue(&glutOverlayDisplayFunc_fun, 0);
  pop_stack();
}

static void f_glutOverlayDisplayFunc(INT32 args)
{
  if(glutOverlayDisplayFunc_fun.type)
    free_svalue(&glutOverlayDisplayFunc_fun);
  assign_svalue_no_free(&glutOverlayDisplayFunc_fun, &sp[-args+0]);

  check_all_args("glutOverlayDisplayFunc", args, BIT_FUNCTION, 0);
  glutOverlayDisplayFunc((void *)&glutOverlayDisplayFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutPassiveMotionFunc_fun;

void glutPassiveMotionFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutPassiveMotionFunc_fun, 2);
  pop_stack();
}

static void f_glutPassiveMotionFunc(INT32 args)
{
  if(glutPassiveMotionFunc_fun.type)
    free_svalue(&glutPassiveMotionFunc_fun);
  assign_svalue_no_free(&glutPassiveMotionFunc_fun, &sp[-args+0]);

  check_all_args("glutPassiveMotionFunc", args, BIT_FUNCTION, 0);
  glutPassiveMotionFunc((void *)&glutPassiveMotionFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutPopWindow(INT32 args)
{
  glutPopWindow();
  pop_n_elems(args);
}

static void f_glutPositionWindow(INT32 args)
{
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutPositionWindow", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutPositionWindow(arg1,arg2);
  pop_n_elems(args);
}

static void f_glutPostOverlayRedisplay(INT32 args)
{
  glutPostOverlayRedisplay();
  pop_n_elems(args);
}

static void f_glutPostRedisplay(INT32 args)
{
  glutPostRedisplay();
  pop_n_elems(args);
}

static void f_glutPostWindowOverlayRedisplay(INT32 args)
{
  INT32 arg1;

  check_all_args("glutPostWindowOverlayRedisplay", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutPostWindowOverlayRedisplay(arg1);
  pop_n_elems(args);
}

static void f_glutPostWindowRedisplay(INT32 args)
{
  INT32 arg1;

  check_all_args("glutPostWindowRedisplay", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutPostWindowRedisplay(arg1);
  pop_n_elems(args);
}

static void f_glutPushWindow(INT32 args)
{
  glutPushWindow();
  pop_n_elems(args);
}

static void f_glutRemoveMenuItem(INT32 args)
{
  INT32 arg1;

  check_all_args("glutRemoveMenuItem", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutRemoveMenuItem(arg1);
  pop_n_elems(args);
}

static void f_glutRemoveOverlay(INT32 args)
{
  glutRemoveOverlay();
  pop_n_elems(args);
}

static void f_glutReportErrors(INT32 args)
{
  glutReportErrors();
  pop_n_elems(args);
}

struct svalue glutReshapeFunc_fun;

void glutReshapeFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutReshapeFunc_fun, 2);
  pop_stack();
}

static void f_glutReshapeFunc(INT32 args)
{
  if(glutReshapeFunc_fun.type)
    free_svalue(&glutReshapeFunc_fun);
  assign_svalue_no_free(&glutReshapeFunc_fun, &sp[-args+0]);

  check_all_args("glutReshapeFunc", args, BIT_FUNCTION, 0);
  glutReshapeFunc((void *)&glutReshapeFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutReshapeWindow(INT32 args)
{
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutReshapeWindow", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutReshapeWindow(arg1,arg2);
  pop_n_elems(args);
}

static void f_glutSetColor(INT32 args)
{
  INT32 arg1;
  float arg2;
  float arg3;
  float arg4;

  check_all_args("glutSetColor", args, BIT_INT, BIT_FLOAT, BIT_FLOAT, BIT_FLOAT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.float_number;
  arg3=sp[2-args].u.float_number;
  arg4=sp[3-args].u.float_number;

  glutSetColor(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

static void f_glutSetCursor(INT32 args)
{
  INT32 arg1;

  check_all_args("glutSetCursor", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutSetCursor(arg1);
  pop_n_elems(args);
}

static void f_glutSetIconTitle(INT32 args)
{
  char *arg1;

  check_all_args("glutSetIconTitle", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  glutSetIconTitle(arg1);
  pop_n_elems(args);
}

static void f_glutSetKeyRepeat(INT32 args)
{
  INT32 arg1;

  check_all_args("glutSetKeyRepeat", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutSetKeyRepeat(arg1);
  pop_n_elems(args);
}

static void f_glutSetMenu(INT32 args)
{
  INT32 arg1;

  check_all_args("glutSetMenu", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutSetMenu(arg1);
  pop_n_elems(args);
}

static void f_glutSetWindow(INT32 args)
{
  INT32 arg1;

  check_all_args("glutSetWindow", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutSetWindow(arg1);
  pop_n_elems(args);
}

static void f_glutSetWindowTitle(INT32 args)
{
  char *arg1;

  check_all_args("glutSetWindowTitle", args, BIT_STRING, 0);

  arg1=sp[0-args].u.string->str;

  glutSetWindowTitle(arg1);
  pop_n_elems(args);
}

static void f_glutSetupVideoResizing(INT32 args)
{
  glutSetupVideoResizing();
  pop_n_elems(args);
}

static void f_glutShowOverlay(INT32 args)
{
  glutShowOverlay();
  pop_n_elems(args);
}

static void f_glutShowWindow(INT32 args)
{
  glutShowWindow();
  pop_n_elems(args);
}

static void f_glutSolidCone(INT32 args)
{
  double arg1;
  double arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutSolidCone", args, BIT_FLOAT, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=(double)sp[1-args].u.float_number;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutSolidCone(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

static void f_glutSolidCube(INT32 args)
{
  double arg1;

  check_all_args("glutSolidCube", args, BIT_FLOAT, 0);

  arg1=(double)sp[0-args].u.float_number;

  glutSolidCube(arg1);
  pop_n_elems(args);
}

static void f_glutSolidDodecahedron(INT32 args)
{
  glutSolidDodecahedron();
  pop_n_elems(args);
}

static void f_glutSolidIcosahedron(INT32 args)
{
  glutSolidIcosahedron();
  pop_n_elems(args);
}

static void f_glutSolidOctahedron(INT32 args)
{
  glutSolidOctahedron();
  pop_n_elems(args);
}

static void f_glutSolidSphere(INT32 args)
{
  double arg1;
  INT32 arg2;
  INT32 arg3;

  check_all_args("glutSolidSphere", args, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=sp[1-args].u.integer;
  arg3=sp[2-args].u.integer;

  glutSolidSphere(arg1,arg2,arg3);
  pop_n_elems(args);
}

static void f_glutSolidTeapot(INT32 args)
{
  double arg1;

  check_all_args("glutSolidTeapot", args, BIT_FLOAT, 0);

  arg1=(double)sp[0-args].u.float_number;

  glutSolidTeapot(arg1);
  pop_n_elems(args);
}

static void f_glutSolidTetrahedron(INT32 args)
{
  glutSolidTetrahedron();
  pop_n_elems(args);
}

static void f_glutSolidTorus(INT32 args)
{
  double arg1;
  double arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutSolidTorus", args, BIT_FLOAT, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=(double)sp[1-args].u.float_number;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutSolidTorus(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

struct svalue glutSpaceballButtonFunc_fun;

void glutSpaceballButtonFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutSpaceballButtonFunc_fun, 2);
  pop_stack();
}

static void f_glutSpaceballButtonFunc(INT32 args)
{
  if(glutSpaceballButtonFunc_fun.type)
    free_svalue(&glutSpaceballButtonFunc_fun);
  assign_svalue_no_free(&glutSpaceballButtonFunc_fun, &sp[-args+0]);

  check_all_args("glutSpaceballButtonFunc", args, BIT_FUNCTION, 0);
  glutSpaceballButtonFunc((void *)&glutSpaceballButtonFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutSpaceballMotionFunc_fun;

void glutSpaceballMotionFunc_cb_wrapper(int arg1, int arg2, int arg3)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutSpaceballMotionFunc_fun, 3);
  pop_stack();
}

static void f_glutSpaceballMotionFunc(INT32 args)
{
  if(glutSpaceballMotionFunc_fun.type)
    free_svalue(&glutSpaceballMotionFunc_fun);
  assign_svalue_no_free(&glutSpaceballMotionFunc_fun, &sp[-args+0]);

  check_all_args("glutSpaceballMotionFunc", args, BIT_FUNCTION, 0);
  glutSpaceballMotionFunc((void *)&glutSpaceballMotionFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutSpaceballRotateFunc_fun;

void glutSpaceballRotateFunc_cb_wrapper(int arg1, int arg2, int arg3)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutSpaceballRotateFunc_fun, 3);
  pop_stack();
}

static void f_glutSpaceballRotateFunc(INT32 args)
{
  if(glutSpaceballRotateFunc_fun.type)
    free_svalue(&glutSpaceballRotateFunc_fun);
  assign_svalue_no_free(&glutSpaceballRotateFunc_fun, &sp[-args+0]);

  check_all_args("glutSpaceballRotateFunc", args, BIT_FUNCTION, 0);
  glutSpaceballRotateFunc((void *)&glutSpaceballRotateFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutSpecialFunc_fun;

void glutSpecialFunc_cb_wrapper(int arg1, int arg2, int arg3)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutSpecialFunc_fun, 3);
  pop_stack();
}

static void f_glutSpecialFunc(INT32 args)
{
  if(glutSpecialFunc_fun.type)
    free_svalue(&glutSpecialFunc_fun);
  assign_svalue_no_free(&glutSpecialFunc_fun, &sp[-args+0]);

  check_all_args("glutSpecialFunc", args, BIT_FUNCTION, 0);
  glutSpecialFunc((void *)&glutSpecialFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutSpecialUpFunc_fun;

void glutSpecialUpFunc_cb_wrapper(int arg1, int arg2, int arg3)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  apply_svalue(&glutSpecialUpFunc_fun, 3);
  pop_stack();
}

static void f_glutSpecialUpFunc(INT32 args)
{
  if(glutSpecialUpFunc_fun.type)
    free_svalue(&glutSpecialUpFunc_fun);
  assign_svalue_no_free(&glutSpecialUpFunc_fun, &sp[-args+0]);

  check_all_args("glutSpecialUpFunc", args, BIT_FUNCTION, 0);
  glutSpecialUpFunc((void *)&glutSpecialUpFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutStopVideoResizing(INT32 args)
{
  glutStopVideoResizing();
  pop_n_elems(args);
}

static void f_glutSwapBuffers(INT32 args)
{
  glutSwapBuffers();
  pop_n_elems(args);
}

struct svalue glutTabletButtonFunc_fun;

void glutTabletButtonFunc_cb_wrapper(int arg1, int arg2, int arg3, int arg4)
{
  push_int(arg1);
  push_int(arg2);
  push_int(arg3);
  push_int(arg4);
  apply_svalue(&glutTabletButtonFunc_fun, 4);
  pop_stack();
}

static void f_glutTabletButtonFunc(INT32 args)
{
  if(glutTabletButtonFunc_fun.type)
    free_svalue(&glutTabletButtonFunc_fun);
  assign_svalue_no_free(&glutTabletButtonFunc_fun, &sp[-args+0]);

  check_all_args("glutTabletButtonFunc", args, BIT_FUNCTION, 0);
  glutTabletButtonFunc((void *)&glutTabletButtonFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutTabletMotionFunc_fun;

void glutTabletMotionFunc_cb_wrapper(int arg1, int arg2)
{
  push_int(arg1);
  push_int(arg2);
  apply_svalue(&glutTabletMotionFunc_fun, 2);
  pop_stack();
}

static void f_glutTabletMotionFunc(INT32 args)
{
  if(glutTabletMotionFunc_fun.type)
    free_svalue(&glutTabletMotionFunc_fun);
  assign_svalue_no_free(&glutTabletMotionFunc_fun, &sp[-args+0]);

  check_all_args("glutTabletMotionFunc", args, BIT_FUNCTION, 0);
  glutTabletMotionFunc((void *)&glutTabletMotionFunc_cb_wrapper);
  pop_n_elems(args);
}

struct svalue glutTimerFunc_fun;

void glutTimerFunc_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutTimerFunc_fun, 1);
  pop_stack();
}

static void f_glutTimerFunc(INT32 args)
{
  INT32 arg1;
  INT32 arg2;
  if(glutTimerFunc_fun.type)
    free_svalue(&glutTimerFunc_fun);
  assign_svalue_no_free(&glutTimerFunc_fun, &sp[-args+1]);

  check_all_args("glutTimerFunc", args, BIT_INT, BIT_FUNCTION, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutTimerFunc(arg1,(void *)&glutTimerFunc_cb_wrapper,arg2);
  pop_n_elems(args);
}

static void f_glutUseLayer(INT32 args)
{
  INT32 arg1;

  check_all_args("glutUseLayer", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  glutUseLayer(arg1);
  pop_n_elems(args);
}

static void f_glutVideoPan(INT32 args)
{
  INT32 arg1;
  INT32 arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutVideoPan", args, BIT_INT, BIT_INT, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutVideoPan(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

static void f_glutVideoResize(INT32 args)
{
  INT32 arg1;
  INT32 arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutVideoResize", args, BIT_INT, BIT_INT, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutVideoResize(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

static void f_glutVideoResizeGet(INT32 args)
{
  INT32 res;
  INT32 arg1;

  check_all_args("glutVideoResizeGet", args, BIT_INT, 0);

  arg1=sp[0-args].u.integer;

  res=glutVideoResizeGet(arg1);
  pop_n_elems(args);
  push_int(res);
}

struct svalue glutVisibilityFunc_fun;

void glutVisibilityFunc_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutVisibilityFunc_fun, 1);
  pop_stack();
}

static void f_glutVisibilityFunc(INT32 args)
{
  if(glutVisibilityFunc_fun.type)
    free_svalue(&glutVisibilityFunc_fun);
  assign_svalue_no_free(&glutVisibilityFunc_fun, &sp[-args+0]);

  check_all_args("glutVisibilityFunc", args, BIT_FUNCTION, 0);
  glutVisibilityFunc((void *)&glutVisibilityFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutWarpPointer(INT32 args)
{
  INT32 arg1;
  INT32 arg2;

  check_all_args("glutWarpPointer", args, BIT_INT, BIT_INT, 0);

  arg1=sp[0-args].u.integer;
  arg2=sp[1-args].u.integer;

  glutWarpPointer(arg1,arg2);
  pop_n_elems(args);
}

struct svalue glutWindowStatusFunc_fun;

void glutWindowStatusFunc_cb_wrapper(int arg1)
{
  push_int(arg1);
  apply_svalue(&glutWindowStatusFunc_fun, 1);
  pop_stack();
}

static void f_glutWindowStatusFunc(INT32 args)
{
  if(glutWindowStatusFunc_fun.type)
    free_svalue(&glutWindowStatusFunc_fun);
  assign_svalue_no_free(&glutWindowStatusFunc_fun, &sp[-args+0]);

  check_all_args("glutWindowStatusFunc", args, BIT_FUNCTION, 0);
  glutWindowStatusFunc((void *)&glutWindowStatusFunc_cb_wrapper);
  pop_n_elems(args);
}

static void f_glutWireCone(INT32 args)
{
  double arg1;
  double arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutWireCone", args, BIT_FLOAT, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=(double)sp[1-args].u.float_number;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutWireCone(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

static void f_glutWireCube(INT32 args)
{
  double arg1;

  check_all_args("glutWireCube", args, BIT_FLOAT, 0);

  arg1=(double)sp[0-args].u.float_number;

  glutWireCube(arg1);
  pop_n_elems(args);
}

static void f_glutWireDodecahedron(INT32 args)
{
  glutWireDodecahedron();
  pop_n_elems(args);
}

static void f_glutWireIcosahedron(INT32 args)
{
  glutWireIcosahedron();
  pop_n_elems(args);
}

static void f_glutWireOctahedron(INT32 args)
{
  glutWireOctahedron();
  pop_n_elems(args);
}

static void f_glutWireSphere(INT32 args)
{
  double arg1;
  INT32 arg2;
  INT32 arg3;

  check_all_args("glutWireSphere", args, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=sp[1-args].u.integer;
  arg3=sp[2-args].u.integer;

  glutWireSphere(arg1,arg2,arg3);
  pop_n_elems(args);
}

static void f_glutWireTeapot(INT32 args)
{
  double arg1;

  check_all_args("glutWireTeapot", args, BIT_FLOAT, 0);

  arg1=(double)sp[0-args].u.float_number;

  glutWireTeapot(arg1);
  pop_n_elems(args);
}

static void f_glutWireTetrahedron(INT32 args)
{
  glutWireTetrahedron();
  pop_n_elems(args);
}

static void f_glutWireTorus(INT32 args)
{
  double arg1;
  double arg2;
  INT32 arg3;
  INT32 arg4;

  check_all_args("glutWireTorus", args, BIT_FLOAT, BIT_FLOAT, BIT_INT, BIT_INT, 0);

  arg1=(double)sp[0-args].u.float_number;
  arg2=(double)sp[1-args].u.float_number;
  arg3=sp[2-args].u.integer;
  arg4=sp[3-args].u.integer;

  glutWireTorus(arg1,arg2,arg3,arg4);
  pop_n_elems(args);
}

void add_auto_funcs_glut()
{
  pre_init();
  add_function_constant("glutAddMenuEntry", f_glutAddMenuEntry,
			"function(string,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutAddSubMenu", f_glutAddSubMenu,
			"function(string,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutAttachMenu", f_glutAttachMenu,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutButtonBoxFunc", f_glutButtonBoxFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutChangeToMenuEntry", f_glutChangeToMenuEntry,
			"function(int,string,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutChangeToSubMenu", f_glutChangeToSubMenu,
			"function(int,string,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutCopyColormap", f_glutCopyColormap,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutCreateMenu", f_glutCreateMenu,
			"function(function:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutCreateSubWindow", f_glutCreateSubWindow,
			"function(int,int,int,int,int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutCreateWindow", f_glutCreateWindow,
			"function(string:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutDestroyMenu", f_glutDestroyMenu,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutDestroyWindow", f_glutDestroyWindow,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutDetachMenu", f_glutDetachMenu,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutDeviceGet", f_glutDeviceGet,
			"function(int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutDialsFunc", f_glutDialsFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutDisplayFunc", f_glutDisplayFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutEnterGameMode", f_glutEnterGameMode,
			"function(:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutEntryFunc", f_glutEntryFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutEstablishOverlay", f_glutEstablishOverlay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutExtensionSupported", f_glutExtensionSupported,
			"function(string:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutForceJoystickFunc", f_glutForceJoystickFunc,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutFullScreen", f_glutFullScreen,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutGameModeGet", f_glutGameModeGet,
			"function(int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutGameModeString", f_glutGameModeString,
			"function(string:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutGet", f_glutGet,
			"function(int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutGetColor", f_glutGetColor,
			"function(int,int:float)", OPT_SIDE_EFFECT);
  add_function_constant("glutGetMenu", f_glutGetMenu,
			"function(:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutGetModifiers", f_glutGetModifiers,
			"function(:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutGetWindow", f_glutGetWindow,
			"function(:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutHideOverlay", f_glutHideOverlay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutHideWindow", f_glutHideWindow,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutIconifyWindow", f_glutIconifyWindow,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutIdleFunc", f_glutIdleFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutIgnoreKeyRepeat", f_glutIgnoreKeyRepeat,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutInitDisplayMode", f_glutInitDisplayMode,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutInitDisplayString", f_glutInitDisplayString,
			"function(string:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutInitWindowPosition", f_glutInitWindowPosition,
			"function(int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutInitWindowSize", f_glutInitWindowSize,
			"function(int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutJoystickFunc", f_glutJoystickFunc,
			"function(function,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutKeyboardFunc", f_glutKeyboardFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutKeyboardUpFunc", f_glutKeyboardUpFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutLayerGet", f_glutLayerGet,
			"function(int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutLeaveGameMode", f_glutLeaveGameMode,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutMainLoop", f_glutMainLoop,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutMenuStateFunc", f_glutMenuStateFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutMenuStatusFunc", f_glutMenuStatusFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutMotionFunc", f_glutMotionFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutMouseFunc", f_glutMouseFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutOverlayDisplayFunc", f_glutOverlayDisplayFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPassiveMotionFunc", f_glutPassiveMotionFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPopWindow", f_glutPopWindow,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPositionWindow", f_glutPositionWindow,
			"function(int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPostOverlayRedisplay", f_glutPostOverlayRedisplay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPostRedisplay", f_glutPostRedisplay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPostWindowOverlayRedisplay", f_glutPostWindowOverlayRedisplay,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPostWindowRedisplay", f_glutPostWindowRedisplay,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutPushWindow", f_glutPushWindow,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutRemoveMenuItem", f_glutRemoveMenuItem,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutRemoveOverlay", f_glutRemoveOverlay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutReportErrors", f_glutReportErrors,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutReshapeFunc", f_glutReshapeFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutReshapeWindow", f_glutReshapeWindow,
			"function(int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetColor", f_glutSetColor,
			"function(int,float,float,float:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetCursor", f_glutSetCursor,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetIconTitle", f_glutSetIconTitle,
			"function(string:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetKeyRepeat", f_glutSetKeyRepeat,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetMenu", f_glutSetMenu,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetWindow", f_glutSetWindow,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetWindowTitle", f_glutSetWindowTitle,
			"function(string:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSetupVideoResizing", f_glutSetupVideoResizing,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutShowOverlay", f_glutShowOverlay,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutShowWindow", f_glutShowWindow,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidCone", f_glutSolidCone,
			"function(float,float,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidCube", f_glutSolidCube,
			"function(float:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidDodecahedron", f_glutSolidDodecahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidIcosahedron", f_glutSolidIcosahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidOctahedron", f_glutSolidOctahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidSphere", f_glutSolidSphere,
			"function(float,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidTeapot", f_glutSolidTeapot,
			"function(float:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidTetrahedron", f_glutSolidTetrahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSolidTorus", f_glutSolidTorus,
			"function(float,float,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSpaceballButtonFunc", f_glutSpaceballButtonFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSpaceballMotionFunc", f_glutSpaceballMotionFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSpaceballRotateFunc", f_glutSpaceballRotateFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSpecialFunc", f_glutSpecialFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSpecialUpFunc", f_glutSpecialUpFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutStopVideoResizing", f_glutStopVideoResizing,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutSwapBuffers", f_glutSwapBuffers,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutTabletButtonFunc", f_glutTabletButtonFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutTabletMotionFunc", f_glutTabletMotionFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutTimerFunc", f_glutTimerFunc,
			"function(int,function,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutUseLayer", f_glutUseLayer,
			"function(int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutVideoPan", f_glutVideoPan,
			"function(int,int,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutVideoResize", f_glutVideoResize,
			"function(int,int,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutVideoResizeGet", f_glutVideoResizeGet,
			"function(int:int)", OPT_SIDE_EFFECT);
  add_function_constant("glutVisibilityFunc", f_glutVisibilityFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWarpPointer", f_glutWarpPointer,
			"function(int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWindowStatusFunc", f_glutWindowStatusFunc,
			"function(function:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireCone", f_glutWireCone,
			"function(float,float,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireCube", f_glutWireCube,
			"function(float:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireDodecahedron", f_glutWireDodecahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireIcosahedron", f_glutWireIcosahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireOctahedron", f_glutWireOctahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireSphere", f_glutWireSphere,
			"function(float,int,int:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireTeapot", f_glutWireTeapot,
			"function(float:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireTetrahedron", f_glutWireTetrahedron,
			"function(:void)", OPT_SIDE_EFFECT);
  add_function_constant("glutWireTorus", f_glutWireTorus,
			"function(float,float,int,int:void)", OPT_SIDE_EFFECT);
  add_integer_constant("GLUT_ACCUM", 4, 0);
  add_integer_constant("GLUT_ACTIVE_ALT", 4, 0);
  add_integer_constant("GLUT_ACTIVE_CTRL", 2, 0);
  add_integer_constant("GLUT_ACTIVE_SHIFT", 1, 0);
  add_integer_constant("GLUT_ALPHA", 8, 0);
  add_integer_constant("GLUT_BLUE", 2, 0);
  add_integer_constant("GLUT_CURSOR_BOTTOM_LEFT_CORNER", 19, 0);
  add_integer_constant("GLUT_CURSOR_BOTTOM_RIGHT_CORNER", 18, 0);
  add_integer_constant("GLUT_CURSOR_BOTTOM_SIDE", 13, 0);
  add_integer_constant("GLUT_CURSOR_CROSSHAIR", 9, 0);
  add_integer_constant("GLUT_CURSOR_CYCLE", 5, 0);
  add_integer_constant("GLUT_CURSOR_DESTROY", 3, 0);
  add_integer_constant("GLUT_CURSOR_FULL_CROSSHAIR", 102, 0);
  add_integer_constant("GLUT_CURSOR_HELP", 4, 0);
  add_integer_constant("GLUT_CURSOR_INFO", 2, 0);
  add_integer_constant("GLUT_CURSOR_INHERIT", 100, 0);
  add_integer_constant("GLUT_CURSOR_LEFT_ARROW", 1, 0);
  add_integer_constant("GLUT_CURSOR_LEFT_RIGHT", 11, 0);
  add_integer_constant("GLUT_CURSOR_LEFT_SIDE", 14, 0);
  add_integer_constant("GLUT_CURSOR_NONE", 101, 0);
  add_integer_constant("GLUT_CURSOR_RIGHT_ARROW", 0, 0);
  add_integer_constant("GLUT_CURSOR_RIGHT_SIDE", 15, 0);
  add_integer_constant("GLUT_CURSOR_SPRAY", 6, 0);
  add_integer_constant("GLUT_CURSOR_TEXT", 8, 0);
  add_integer_constant("GLUT_CURSOR_TOP_LEFT_CORNER", 16, 0);
  add_integer_constant("GLUT_CURSOR_TOP_RIGHT_CORNER", 17, 0);
  add_integer_constant("GLUT_CURSOR_TOP_SIDE", 12, 0);
  add_integer_constant("GLUT_CURSOR_UP_DOWN", 10, 0);
  add_integer_constant("GLUT_CURSOR_WAIT", 7, 0);
  add_integer_constant("GLUT_DEPTH", 16, 0);
  add_integer_constant("GLUT_DEVICE_IGNORE_KEY_REPEAT", 610, 0);
  add_integer_constant("GLUT_DEVICE_KEY_REPEAT", 611, 0);
  add_integer_constant("GLUT_DISPLAY_MODE_POSSIBLE", 400, 0);
  add_integer_constant("GLUT_DOUBLE", 2, 0);
  add_integer_constant("GLUT_DOWN", 0, 0);
  add_integer_constant("GLUT_ELAPSED_TIME", 700, 0);
  add_integer_constant("GLUT_ENTERED", 1, 0);
  add_integer_constant("GLUT_FULLY_COVERED", 3, 0);
  add_integer_constant("GLUT_FULLY_RETAINED", 1, 0);
  add_integer_constant("GLUT_GAME_MODE_ACTIVE", 0, 0);
  add_integer_constant("GLUT_GAME_MODE_DISPLAY_CHANGED", 6, 0);
  add_integer_constant("GLUT_GAME_MODE_HEIGHT", 3, 0);
  add_integer_constant("GLUT_GAME_MODE_PIXEL_DEPTH", 4, 0);
  add_integer_constant("GLUT_GAME_MODE_POSSIBLE", 1, 0);
  add_integer_constant("GLUT_GAME_MODE_REFRESH_RATE", 5, 0);
  add_integer_constant("GLUT_GAME_MODE_WIDTH", 2, 0);
  add_integer_constant("GLUT_GREEN", 1, 0);
  add_integer_constant("GLUT_HAS_DIAL_AND_BUTTON_BOX", 603, 0);
  add_integer_constant("GLUT_HAS_JOYSTICK", 612, 0);
  add_integer_constant("GLUT_HAS_KEYBOARD", 600, 0);
  add_integer_constant("GLUT_HAS_MOUSE", 601, 0);
  add_integer_constant("GLUT_HAS_OVERLAY", 802, 0);
  add_integer_constant("GLUT_HAS_SPACEBALL", 602, 0);
  add_integer_constant("GLUT_HAS_TABLET", 604, 0);
  add_integer_constant("GLUT_HIDDEN", 0, 0);
  add_integer_constant("GLUT_INDEX", 1, 0);
  add_integer_constant("GLUT_INIT_DISPLAY_MODE", 504, 0);
  add_integer_constant("GLUT_INIT_WINDOW_HEIGHT", 503, 0);
  add_integer_constant("GLUT_INIT_WINDOW_WIDTH", 502, 0);
  add_integer_constant("GLUT_INIT_WINDOW_X", 500, 0);
  add_integer_constant("GLUT_INIT_WINDOW_Y", 501, 0);
  add_integer_constant("GLUT_JOYSTICK_AXES", 615, 0);
  add_integer_constant("GLUT_JOYSTICK_BUTTONS", 614, 0);
  add_integer_constant("GLUT_JOYSTICK_BUTTON_A", 1, 0);
  add_integer_constant("GLUT_JOYSTICK_BUTTON_B", 2, 0);
  add_integer_constant("GLUT_JOYSTICK_BUTTON_C", 4, 0);
  add_integer_constant("GLUT_JOYSTICK_BUTTON_D", 8, 0);
  add_integer_constant("GLUT_JOYSTICK_POLL_RATE", 616, 0);
  add_integer_constant("GLUT_KEY_DOWN", 103, 0);
  add_integer_constant("GLUT_KEY_END", 107, 0);
  add_integer_constant("GLUT_KEY_F1", 1, 0);
  add_integer_constant("GLUT_KEY_F10", 10, 0);
  add_integer_constant("GLUT_KEY_F11", 11, 0);
  add_integer_constant("GLUT_KEY_F12", 12, 0);
  add_integer_constant("GLUT_KEY_F2", 2, 0);
  add_integer_constant("GLUT_KEY_F3", 3, 0);
  add_integer_constant("GLUT_KEY_F4", 4, 0);
  add_integer_constant("GLUT_KEY_F5", 5, 0);
  add_integer_constant("GLUT_KEY_F6", 6, 0);
  add_integer_constant("GLUT_KEY_F7", 7, 0);
  add_integer_constant("GLUT_KEY_F8", 8, 0);
  add_integer_constant("GLUT_KEY_F9", 9, 0);
  add_integer_constant("GLUT_KEY_HOME", 106, 0);
  add_integer_constant("GLUT_KEY_INSERT", 108, 0);
  add_integer_constant("GLUT_KEY_LEFT", 100, 0);
  add_integer_constant("GLUT_KEY_PAGE_DOWN", 105, 0);
  add_integer_constant("GLUT_KEY_PAGE_UP", 104, 0);
  add_integer_constant("GLUT_KEY_REPEAT_DEFAULT", 2, 0);
  add_integer_constant("GLUT_KEY_REPEAT_OFF", 0, 0);
  add_integer_constant("GLUT_KEY_REPEAT_ON", 1, 0);
  add_integer_constant("GLUT_KEY_RIGHT", 102, 0);
  add_integer_constant("GLUT_KEY_UP", 101, 0);
  add_integer_constant("GLUT_LAYER_IN_USE", 801, 0);
  add_integer_constant("GLUT_LEFT", 0, 0);
  add_integer_constant("GLUT_LEFT_BUTTON", 0, 0);
  add_integer_constant("GLUT_LUMINANCE", 512, 0);
  add_integer_constant("GLUT_MENU_IN_USE", 1, 0);
  add_integer_constant("GLUT_MENU_NOT_IN_USE", 0, 0);
  add_integer_constant("GLUT_MENU_NUM_ITEMS", 300, 0);
  add_integer_constant("GLUT_MIDDLE_BUTTON", 1, 0);
  add_integer_constant("GLUT_MULTISAMPLE", 128, 0);
  add_integer_constant("GLUT_NORMAL", 0, 0);
  add_integer_constant("GLUT_NORMAL_DAMAGED", 804, 0);
  add_integer_constant("GLUT_NOT_VISIBLE", 0, 0);
  add_integer_constant("GLUT_NUM_BUTTON_BOX_BUTTONS", 607, 0);
  add_integer_constant("GLUT_NUM_DIALS", 608, 0);
  add_integer_constant("GLUT_NUM_MOUSE_BUTTONS", 605, 0);
  add_integer_constant("GLUT_NUM_SPACEBALL_BUTTONS", 606, 0);
  add_integer_constant("GLUT_NUM_TABLET_BUTTONS", 609, 0);
  add_integer_constant("GLUT_OVERLAY", 1, 0);
  add_integer_constant("GLUT_OVERLAY_DAMAGED", 805, 0);
  add_integer_constant("GLUT_OVERLAY_POSSIBLE", 800, 0);
  add_integer_constant("GLUT_OWNS_JOYSTICK", 613, 0);
  add_integer_constant("GLUT_PARTIALLY_RETAINED", 2, 0);
  add_integer_constant("GLUT_RED", 0, 0);
  add_integer_constant("GLUT_RGB", 0, 0);
  add_integer_constant("GLUT_RGBA", 0, 0);
  add_integer_constant("GLUT_RIGHT_BUTTON", 2, 0);
  add_integer_constant("GLUT_SCREEN_HEIGHT", 201, 0);
  add_integer_constant("GLUT_SCREEN_HEIGHT_MM", 203, 0);
  add_integer_constant("GLUT_SCREEN_WIDTH", 200, 0);
  add_integer_constant("GLUT_SCREEN_WIDTH_MM", 202, 0);
  add_integer_constant("GLUT_SINGLE", 0, 0);
  add_integer_constant("GLUT_STENCIL", 32, 0);
  add_integer_constant("GLUT_STEREO", 256, 0);
  add_integer_constant("GLUT_TRANSPARENT_INDEX", 803, 0);
  add_integer_constant("GLUT_UP", 1, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_HEIGHT", 909, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_HEIGHT_DELTA", 905, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_IN_USE", 901, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_POSSIBLE", 900, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_WIDTH", 908, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_WIDTH_DELTA", 904, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_X", 906, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_X_DELTA", 902, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_Y", 907, 0);
  add_integer_constant("GLUT_VIDEO_RESIZE_Y_DELTA", 903, 0);
  add_integer_constant("GLUT_VISIBLE", 1, 0);
  add_integer_constant("GLUT_WINDOW_ACCUM_ALPHA_SIZE", 114, 0);
  add_integer_constant("GLUT_WINDOW_ACCUM_BLUE_SIZE", 113, 0);
  add_integer_constant("GLUT_WINDOW_ACCUM_GREEN_SIZE", 112, 0);
  add_integer_constant("GLUT_WINDOW_ACCUM_RED_SIZE", 111, 0);
  add_integer_constant("GLUT_WINDOW_ALPHA_SIZE", 110, 0);
  add_integer_constant("GLUT_WINDOW_BLUE_SIZE", 109, 0);
  add_integer_constant("GLUT_WINDOW_BUFFER_SIZE", 104, 0);
  add_integer_constant("GLUT_WINDOW_COLORMAP_SIZE", 119, 0);
  add_integer_constant("GLUT_WINDOW_CURSOR", 122, 0);
  add_integer_constant("GLUT_WINDOW_DEPTH_SIZE", 106, 0);
  add_integer_constant("GLUT_WINDOW_DOUBLEBUFFER", 115, 0);
  add_integer_constant("GLUT_WINDOW_FORMAT_ID", 123, 0);
  add_integer_constant("GLUT_WINDOW_GREEN_SIZE", 108, 0);
  add_integer_constant("GLUT_WINDOW_HEIGHT", 103, 0);
  add_integer_constant("GLUT_WINDOW_NUM_CHILDREN", 118, 0);
  add_integer_constant("GLUT_WINDOW_NUM_SAMPLES", 120, 0);
  add_integer_constant("GLUT_WINDOW_PARENT", 117, 0);
  add_integer_constant("GLUT_WINDOW_RED_SIZE", 107, 0);
  add_integer_constant("GLUT_WINDOW_RGBA", 116, 0);
  add_integer_constant("GLUT_WINDOW_STENCIL_SIZE", 105, 0);
  add_integer_constant("GLUT_WINDOW_STEREO", 121, 0);
  add_integer_constant("GLUT_WINDOW_WIDTH", 102, 0);
  add_integer_constant("GLUT_WINDOW_X", 100, 0);
  add_integer_constant("GLUT_WINDOW_Y", 101, 0);
  post_init();
}


